#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    long long brojTakmicara, brojDa, brojNe, temp, x, prviNe, res;

    cin >> brojTakmicara;

    for(long long a = 0; a < brojTakmicara; a++){
        cin >> brojDa >> brojNe;
        res = 1;
        vector<long long> da(brojDa);
        vector<long long> ne(brojNe);
        for(int i = 0; i < brojDa; i++) cin >> da[i];
        sort(da.begin(), da.end());
        x = abs(da[1] - da[0]);
        for(int i = 2; i < brojDa; i++){
            x = min(x, abs(da[i] - da[i - 1]));
        }
        cin >> prviNe;
        for(int i = 1; i < brojNe; i++){
            cin >> temp;
            if(abs(temp - prviNe) % x == 0) res = 0;
            prviNe = temp;
        }
        cout << res << endl;

    }

    return 0;
}